#!/usr/bin/env bash

DOCKER_PATH="."
DOCKER_COMPOSE_PROJECT_NAME=$( basename $( dirname `pwd` ) )

docker:install() {
    docker:run build
}

docker:update() {
    docker:install
}

docker:run() {
    (
        cd "${DOCKER_PATH}" && \
        COMPOSE_PROJECT_NAME="${DOCKER_COMPOSE_PROJECT_NAME}" docker-compose "$@"
    )
}

docker:container_run() {
    docker:run run -T --rm "$@"
}

task:docker-compose() {
    docker:run "$@"
}
